game = {}

game_pause = false
game_pause_screen = love.graphics.newImage(love.graphics.newScreenshot())

game_time = {c = 60, m = 60}

local first = true

local shdata = love.image.newImageData(screen.w, screen.h)
for y=0, shdata:getHeight() - 1 do
	for x=0, shdata:getWidth() - 1 do
		shdata:setPixel(x, y, 255, 255, 255, 255)
	end
end
local sh = love.graphics.newImage(shdata)

--HUD SHIT


function game.reset()
	if first then
		if shaders_enabled then
			note.new("Shaders  Enabled (press 'o' to toggle)", color_blue)
		else
			note.new("Shaders  Disabled", color_red)
		end
		note.new("Controls: A and D or LEFT and RIGHT to move, W or SPACE to jump, LMB do shoot", color_blue, 5)
		first = false
	end
	
	
	player.reset()
	obj.reset()
	ent.reset()
	
	game_time.c = game_time.m
	
end

function game.update(dt)
	if not game_pause then
		game_time.c = game_time.c - dt
		world.update(dt)
		obj.update(dt)
		ent.update(dt)
		shaders.light.update(dt)
		player.update(dt)
		note.update(dt)
		
		--Death/loss check
		if player.health.c < 0 or game_time.c < 0 then
			player.health.c = 0
			note.new("Game over. You collected $"..player.money, color_blue, 5)
			game.reset()
		end
		
		hud.update(dt)
		
	end
end

function game.draw()
	if game_pause then
		shaders.pause.set()
		love.graphics.draw(game_pause_screen)
	else
	world.draw()
	
	obj.draw()
	ent.draw()

	player.draw()
	note.draw()
	
	shaders.clear()
	
	hud.draw()
	
	end
end

function game.keypressed(key)
	if not game_pause then
		player.keypressed(key)
	end
	
	if key == "p" then
		game_pause = not game_pause
		if game_pause then
			game_pause_screen = love.graphics.newImage(love.graphics.newScreenshot())
		end
	end
end

function game.mousepressed(x, y, k)
	if not game_pause then
		player.mousepressed(x, y, k)
		
		if k == "r" and debug_enabled then
			--obj.spawn(x, y, 2)
			ent.spawn(ent_type.ammo, x, y, 1, 64)
		end
	end
end