note = {}
	
	
local notes = {}

--Note settings
local note_x = 12
local note_y = 12
local note_space = 16
local note_duration = 2 --Default duration
local note_scrollSpeed = 300
local note_fadeSpeed = 800

color_red = {200, 0, 0}
color_white = {255, 255, 255}
color_blue = {0, 180, 255}

	
function note.new(t, c, d)
	local dur = 1
	if d == nil then
		dur = note_duration
	else
		dur = d
	end
	
	notes[#notes + 1] = {
			s = t,
			x = note_x,
			y = note_y,
			dy = note_y,
			t = dur,
			a = 0,
			c = c
		}
	for i=1, #notes - 1 do
		notes[i].dy = notes[i].y + note_space
	end

end

function note.update(dt)
	for i,v in ipairs(notes) do
		--Move up
		v.y = v.y - note_scrollSpeed * dt
		if v.y < v.dy then
			v.y = v.dy
		end
		--Fade in
		if v.t > 0 then
			v.a = v.a + note_fadeSpeed * dt
			if v.a > 255 then
				v.a = 255
			end
			--Duration
			v.t = v.t - dt
		else
			v.a = v.a - note_fadeSpeed * dt
			if v.a < 0 then
				table.remove(notes, i)
			end
		end
	end
end

function note.draw()
	for i,v in ipairs(notes) do
		love.graphics.setColor(v.c[1], v.c[2], v.c[3], v.a)
		love.graphics.print(v.s, v.x, v.y)
	end
end




























