shaders_enabled = true


if not love.graphics.isSupported("pixeleffect") then
	shaders_enabled = false
end 


shaders = {
		light = {
				enabled = true,
				size = 0.005,
				s = love.graphics.newPixelEffect [[
							extern vec2 pos;
							extern number  size;
							vec4 effect(vec4 color, Image tex, vec2 tc, vec2 pc)
							{
								vec4 pixel = Texel(tex, tc) * color;
								number dist = distance(pos, pc);
								pixel.r  = 0.0 + (pixel.r / (dist * size));
								pixel.g  = 0.0 + (pixel.g / (dist * size));
								pixel.b  = 0.0 + (pixel.b / (dist * size));
								return pixel;
							}
						]]
			},
		pause = {
				enabled = false,
				s = love.graphics.newPixelEffect [[
							vec4 effect(vec4 color, Image tex, vec2 tc, vec2 pc)
							{
								vec4 pixel = Texel(tex, tc) * color;
								number a = (pixel.r + pixel.g + pixel.b) / 3.0;
								pixel.r = a;
								pixel.g = a;
								pixel.b = a;
								return pixel;
							}
						]]
			}
	}
	
function shaders.clear()
	love.graphics.setPixelEffect()
end

--LIGHT	
function shaders.light.update(dt)
	if shaders.light.enabled and shaders_enabled then
		if gamestate == state.game then
			local pos = {player.x + (player.w / 2), -(player.y + (player.h / 2) - screen.h / 2 - 360)}
			shaders.light.s:send("size", shaders.light.size)
			shaders.light.s:send("pos", pos)
		elseif gamestate == state.menu then
			local pos = {love.mouse.getX(), -love.mouse.getY() + screen.h}
			shaders.light.s:send("size", shaders.light.size)
			shaders.light.s:send("pos", pos)
		end
	end
end

function shaders.light.set()
	if shaders_enabled then
		love.graphics.setPixelEffect(shaders.light.s)
	end
end

--PAUSE

function shaders.pause.set()
	if shaders_enabled then
		love.graphics.setPixelEffect(shaders.pause.s)
	end
end

